var map;
var markersId=new Array();
var markersPos = new Array();
var poligono;
var poligonoNuevo;
var recorrido= new Array();

var markerId=0;
var allMarkersDelete=[];
var allPoligonosDelete=[];
var dibujoRecorridoHijo=0;

var circuloBuscador;

var uniqueId = function()
{
    return ++markerId;
}


function mostrarBtnGuardar()
{
    $("#btnGuardar").css("display","block");
}

function iniciarMapa(lat, lng)
{
    //Borro todo asi puedo volver a generar el mapa vacio
    markersId=new Array();
    markersPos = new Array();
    poligono=null;
    recorrido= new Array();
    markerId=0;
    allMarkersDelete=[];

    generarMapa('map', 15, lat, lng, '');
}

function generarMapa(div, zoom, lat, long, tipoMapa)
{
    $("#btnVerRecorrido").css("display","none");
    if(tipoMapa == 'satelital')
        tipoMapa = google.maps.MapTypeId.SATELLITE;
    else if(tipoMapa == 'fisico')
        tipoMapa = google.maps.MapTypeId.TERRAIN;
    else if(tipoMapa == 'hibrido')
        tipoMapa = google.maps.MapTypeId.HYBRID;
    else
        tipoMapa = google.maps.MapTypeId.ROADMAP;

    var options =
    {
        zoom: zoom
        , center: new google.maps.LatLng(lat, long)
        , mapTypeId: tipoMapa
        , mapTypeControl: true,
        mapTypeControlOptions: {
            style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR
        },
        navigationControl: true,
        navigationControlOptions: {
            style: google.maps.NavigationControlStyle.SMALL,
        }
    };
    map = new google.maps.Map(document.getElementById(div), options);
}


function agregarPostes()
{

    map.addListener('click', function(e)
    {
        obtenerCoordenadas(e, map);
        var pos = {lat: e.latLng.lat(), lng: e.latLng.lng()};
        var id = uniqueId();
        //veo que icono tengo q agregar
        icono = icons[$("input[type='radio']:checked").val()];

        var marker = new google.maps.Marker({
            id:id,
            position: pos,
            map: map,
            tipo: $("input[type='radio']:checked").val(),
            icon: 'images/google/'+icono
        });
        //map.setCenter(marker.getPosition());

        $("#btnVerRecorrido").css("display","block");

        markersId[id] = marker;
        markersPos[id] = marker.getPosition();
        allMarkersDelete.push(marker);

        google.maps.event.addListener(marker, 'dblclick', function () {
            var markerMap = markersId[id];
            markerMap.setMap(null);
            markersId[id]=null;
            markersPos[id]=null;

            //limpiarRuta();
            if(poligonoNuevo)
                poligonoNuevo.setMap(null);
        });
    });
}


function obtenerCoordenadas(e, map)
{
    recorrido.push(e.latLng);
}

function marcarCoop()
{
    $.ajax(
    {
        type: "POST",
        url: "ajax/recorrido.php",
        data: "ini=1",
        dataType : 'json',
        success: function(respuesta){
            var id = uniqueId();
            var pos = {lat: parseFloat(respuesta.lat), lng: parseFloat(respuesta.lng)};

            var marker = new google.maps.Marker({
                id:id,
                position: pos,
                map: map,
                tipo: MAPA_COOP,
                icon: 'images/google/'+icons[MAPA_COOP]
            });

            markersId[id] = marker;
            markersPos[id] = marker.getPosition();
            allMarkersDelete.push(marker);

            map.setCenter(marker.getPosition());
        }
    });
}


function verRecorrido()
{
    var html="";
    var arrayDeCoordenadas = [];
    for(ii=0;ii<markersId.length;ii++)
    {
        if(markersId[ii])
        {
            var coord = new google.maps.LatLng(parseFloat(markersPos[ii].lat()), parseFloat(markersPos[ii].lng()));
            arrayDeCoordenadas.push(coord);
        }
    }

    poligono = new google.maps.Polyline(
    {
      path: arrayDeCoordenadas,
      strokeColor: "#FF0000",
      strokeOpacity: 1.0,
      strokeWeight: 2
    });

    allPoligonosDelete.push(poligono);

    poligono.setMap(map);
}


function verPosibleRecorrido()
{
    //borro los poligonos
    for (var i = 0; i < allPoligonosDelete.length; i++)
    {
        allPoligonosDelete[i].setMap(null);
    }

    var html="";
    var arrayDeCoordenadas = [];
    for(ii=0;ii<markersId.length;ii++)
    {
        if(markersId[ii])
        {
            var coord = new google.maps.LatLng(parseFloat(markersPos[ii].lat()), parseFloat(markersPos[ii].lng()));
            arrayDeCoordenadas.push(coord);
        }
    }

    poligonoNuevo = new google.maps.Polyline(
    {
      path: arrayDeCoordenadas,
      strokeColor: "#FF0000",
      strokeOpacity: 1.0,
      strokeWeight: 2
    });

    allPoligonosDelete.push(poligonoNuevo);

    poligonoNuevo.setMap(map);
}


function limpiarRuta()
{
    for(i=0;i<allPoligonosDelete.length;i++)
    {
        aux = allPoligonosDelete[i];
        aux.setMap(null);
    }
    if(poligono)
        poligono.setMap(null);

    recorrido = [];
    recorrido.length=0;

    //BORRO todas lsa marcas y poligonos
    for(i=0;i<markersId.length;i++)
    {
        if(markersId[i])
        {
            aux = markersId[i];
            aux.setMap(null);
        }
    }
    markersId=new Array();
    markersPos=new Array();

    for (var i = 0; i < allMarkersDelete.length; i++)
    {
        allMarkersDelete[i].setMap(null);
    }

    marcarCoop();
    //iniciarMapa();

}

function marcarEquipamientoEnElMapa(idEquipamiento)
{
    //Veo si el equipo tiene recorrido, y sino tiene mustro el recorrido del padre
    $.ajax(
    {
        type: "POST",
        url: "ajax/infoequipo.php",
        data: "id="+idEquipamiento,
        dataType : 'json',
        success: function(respuesta)
        {
            if(respuesta.Recorrido)
                marcarEquipamientoMapa(idEquipamiento);
        }
    });
}

function marcarEquipamientoMapa(idEquipamiento)
{
    if(idEquipamiento)
    {
        var infowindow = new google.maps.InfoWindow();
        $.ajax(
        {
            type: "POST",
            url: "ajax/recorrido.php",
            data: "ini=0&idE="+idEquipamiento,
            dataType : 'json',
            success: function(respuesta)
            {
                //Ejemplo de lo que llega: {"lat0":"-33.244143","lng0":"-61.355772","tipo0":"coop","lat1":"-33.24471753736992","lng1":"-61.355037689208984","tipo1":"poste","cantPuntos":"2"}

                limpiarRuta();
                nombreAnt="";
                idpuntoAnt="";
                tipoAnt="";
                soloCoop=1;
                for(i=0;i<respuesta.cantPuntos;i++)
                {
                    //Para ver si dibujo algun recorrido
                    dibujoRecorridoHijo=1;

                    idpunto = respuesta["id"+i];
                    imagen = respuesta["imagen"+i];
                    lat = respuesta["lat"+i];
                    lng = respuesta["lng"+i];
                    tipo = respuesta["tipo"+i];
                    nombre = respuesta["nombrePunto"+i];
                    icono = tipo;
                    //para saber si solo marco la coop
                    if(i!=0&&tipo>0)
                        soloCoop=0;

                    var id = uniqueId();
                    var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};

                    var marker = new google.maps.Marker({
                        id:id,
                        position: pos,
                        map: map,
                        tipo: tipo,
                        icon: 'images/google/'+icons[tipo]
                    });

                    if(i>0 && nombreAnt!=nombre && nombre!="" && nombre!=null && nombreAnt!="")
                    {
                        google.maps.event.addListener(marker, 'click', (function (marker,idpuntoAnt,tipoAnt)
                        {
                            return function ()
                            {
                                if(marker.tipo != MAPA_PUNTO && marker.tipo != MAPA_COOP){
                                    //Me fijo si el primer caracter es alguna de las letras
                                    if(idpuntoAnt.substr(0,1)=="E" || idpuntoAnt.substr(0,1)=="O" || idpuntoAnt.substr(0,1)=="C" || idpuntoAnt.substr(0,1)=="D" || idpuntoAnt.substr(0,1)=="W")
                                        idpuntoAnt = idpuntoAnt.substr(1);
                                    $.ajax({
                                        url: 'ajax/infopunto.php?id='+idpuntoAnt+'&tipo='+tipoAnt,
                                        dataType : 'json',
                                        success: function(respuesta){
                                          infowindow.setContent(respuesta.data);
                                          infowindow.open(map, marker);
                                        }
                                    });
                                }
                            };
                        })(marker,idpuntoAnt,tipoAnt));
                    }

                    nombreAnt = nombre;
                    tipoAnt = tipo;
                    idpuntoAnt = idpunto;

                    markersId[id] = marker;
                    markersPos[id] = marker.getPosition();
                    allMarkersDelete.push(marker);

                    map.setCenter(marker.getPosition());

                }
                //Agrego la ultima informacion
                if(i>0)
                {
                    //agregarInformacion(marker, nombre);
                    google.maps.event.addListener(marker, 'click', (function (marker,idpuntoAnt,tipoAnt)
                    {
                        return function ()
                        {
                            if(marker.tipo != MAPA_PUNTO && marker.tipo != MAPA_COOP){
                                //Me fijo si el primer caracter es alguna de las letras
                                if(idpuntoAnt.substr(0,1)=="E" || idpuntoAnt.substr(0,1)=="O" || idpuntoAnt.substr(0,1)=="C" || idpuntoAnt.substr(0,1)=="D" || idpuntoAnt.substr(0,1)=="W")
                                    idpuntoAnt = idpuntoAnt.substr(1);
                                $.ajax({
                                    url: 'ajax/infopunto.php?id='+idpuntoAnt+'&tipo='+tipoAnt,
                                    dataType : 'json',
                                    success: function(respuesta){
                                      infowindow.setContent(respuesta.data);
                                      infowindow.open(map, marker);
                                    }
                                });
                            }
                        };
                    })(marker,idpuntoAnt,tipoAnt));

                    //si solo marco la coop, no tiene recorrido
                    if(soloCoop)
                    {
                        agregarPostes();
                    }
                }
                else
                {
                    agregarPostes();
                }
                verRecorrido();

                //Limpio los array, salvo el ultimo punto, porque tengo q guardar desde el ultimo punto en adelante
                //para seguir cargando puntos
                var ultimoId;
                var ultimoPos;
                for(i=0;i<markersId.length;i++)
                {
                    if(markersId[i])
                    {
                        ultimoId=markersId[i];
                        ultimoPos=markersPos[i];
                    }
                }
                markersId=new Array();
                markersPos=new Array();
                markerId=0;
                var id = uniqueId();
                markersId[id]=ultimoId;
                markersPos[id]=ultimoPos;
                //allMarkersDelete.push(ultimoId);
            }
        });
    }
}


function agregarInformacion(marker, message)
{
    var infoWindow = new google.maps.InfoWindow(
    {
        content: message
    });

    google.maps.event.addListener(marker, 'click', function ()
    {
        infoWindow.open(map, marker);
    });
}

function guardarPuntoExistente()
{
    var devolverRecorrido="";
    var ultLat="";
    var ultLng="";
    //
    if($("#idEquipo").val()!="")
    {
        for(i=0;i<markersId.length;i++)
        {
            //Armar el string para devolver
            //lat@lng|tipo###lat@lng|tipo###lat@lng|tipo###lat@lng|tipo###

            if(markersId[i])
            {
                //en el ultimo punto tengo q guardar el tipo que estoy cargando
                //por mas que pongo otro icono
                tipoIcono = markersId[i].tipo;
                if(markersId.length == (i+1))
                    tipoIcono = $("#id_tipo").val();

                devolverRecorrido+=parseFloat(markersPos[i].lat()).toFixed(7)+"@"+parseFloat(markersPos[i].lng()).toFixed(7)+"|"+tipoIcono+"###";

                //Me quedo con la ultima lat y lng para devolver al form
                ultLat = parseFloat(markersPos[i].lat());
                ultLng = parseFloat(markersPos[i].lng());
            }
        }

        if(devolverRecorrido!="" && ultLat != "" && ultLng != "")
        {
            var variables = "idEquipo="+$("#idEquipo").val()+"&r="+devolverRecorrido+"&lat="+ultLat+"&lng="+ultLng;
            //Guardo en Base el recorrido
            $.ajax(
            {
                type: "POST",
                url: "ajax/updaterecorrido.php",
                data: variables,
                dataType : 'json',
                success: function(respuesta)
                {
                    //poligono.setMap(null);
                    recorrido = [];
                    recorrido.length=0;

                    //BORRO todas lsa marcas y poligonos
                    for(i=0;i<markersId.length;i++)
                    {
                        if(markersId[i])
                        {
                            aux = markersId[i];
                            aux.setMap(null);
                        }
                    }
                    markersId=new Array();
                    markersPos=new Array();
                    iniciarMapa();

                    $("#recorrido").empty();
                    //Agrego la coop en el mapa para poder cargar otros puntos
                    ////marcarCoop();

                    //vuelvo a cargar los datos de tipo y equipamiento
                    $("#cmbTipo").empty();
                    $("#cmbEquipamiento").empty();
                    $("#txtTitulo").val("");
                    ////cargarTipoEquipamiento();

                    setTimeout('window.close();', 100);
                }
            });

        }


    }
    else
    {
        alert(txtMapaAlertNoHayEquipamientoSel);
    }

}

function borrarHastaElPadre()
{
    if($("#idEquipamientoPadre").val() != "")
    {
        marcarEquipamientoMapa($("#idEquipamientoPadre").val());
    }
}
