var map;
var markersId=new Array();
var markersPos = new Array();
var poligono;
var poligonoNuevo;
var recorrido= new Array();

var markerId=0;
var allMarkersDelete=[];
var allPoligonosDelete=[];

var circuloBuscador;

var uniqueId = function()
{
    return ++markerId;
};


function menuUbicarEquipamiento(){
    $("#VerEquipamiento").css("display","none");
    $("#UbicarEquipamiento").css("display","block");

    $("#btnGuardar").css("display","none");

    iniciarMapa();
}
function menuVerMapaCompleto(){
    $("#VerEquipamiento").css("display","block");
    $("#UbicarEquipamiento").css("display","none");

    verEnElMapa('todo');
}

function mostrarBtnGuardar(){
    $("#btnGuardar").css("display","block");
}

function iniciarMapa()
{
    //Borro todo asi puedo volver a generar el mapa vacio
    markersId=new Array();
    markersPos = new Array();
    poligono=null;
    recorrido= new Array();
    markerId=0;
    allMarkersDelete=[];

    generarMapa('map', 15,-35.001153, -61.039800, '');

    //Marco por default la coop
    marcarCoop();

    cargarTipoEquipamiento();

    //Cargo este input para poder marcar en el mapa y solo hacer update del recorrido
    $.ajax(
    {
        type: "POST",
        url: "../ajax/listarequipamientos.php",
        data: "todos=1",
        dataType : 'json',
        success: function(respuesta){
            $('#cmbEquipamientoHijos option').remove();
            $.each(respuesta, function(val, text) {
                $("#cmbEquipamientoHijos").append("<option value='"+val.replace("@@@","")+"'>"+text+"</option>");
            });
            listarCiudades();
        }
    });



    //generarPuntosAleatorios(-35.001153, -61.039800);
}
function mapaNuevoConCoop(){
    //Borro todo asi puedo volver a generar el mapa vacio
    markersId=new Array();
    markersPos = new Array();
    poligono=null;
    recorrido= new Array();
    markerId=0;
    allMarkersDelete=[];

    generarMapa('map', 15,-35.001153, -61.039800, '');

    //Marco por default la coop
    marcarCoop();
}

function generarMapa(div, zoom, lat, long, tipoMapa){
    if(tipoMapa == 'satelital')
        tipoMapa = google.maps.MapTypeId.SATELLITE;
    else if(tipoMapa == 'fisico')
        tipoMapa = google.maps.MapTypeId.TERRAIN;
    else if(tipoMapa == 'hibrido')
        tipoMapa = google.maps.MapTypeId.HYBRID;
    else
        tipoMapa = google.maps.MapTypeId.ROADMAP;

    var options = {
        zoom: zoom
        , center: new google.maps.LatLng(lat, long)
        , mapTypeId: tipoMapa
    };
    map = new google.maps.Map(document.getElementById(div), options);



    map.addListener('click', function(e) {
        obtenerCoordenadas(e, map);
        var pos = {lat: e.latLng.lat(), lng: e.latLng.lng()};
        var id = uniqueId();
        //veo que icono tengo q agregar
        icono = $("input[type='radio']:checked").val()+".png";

        var marker = new google.maps.Marker({
            id:id,
            position: pos,
            map: map,
            tipo: $("input[type='radio']:checked").val(),
            icon: '../images/google/'+icono
        });
        //map.setCenter(marker.getPosition());

        markersId[id] = marker;
        markersPos[id] = marker.getPosition();
        allMarkersDelete.push(marker);

        //cambio el tam. del icon segun zoom
        google.maps.event.addListener(map, 'zoom_changed', function() {
            var zoom = map.getZoom();
            changeIconZoom(zoom);
        });

        google.maps.event.addListener(marker, 'dblclick', function () {
            var markerMap = markersId[id];
            markerMap.setMap(null);
            markersId[id]=null;
            markersPos[id]=null;

            //limpiarRuta();
            if(poligonoNuevo)
                poligonoNuevo.setMap(null);
        });
    });
}

function obtenerCoordenadas(e, map){
    recorrido.push(e.latLng);
}



function verRecorrido(){
    var html="";
    var arrayDeCoordenadas = [];
    for(ii=0;ii<markersId.length;ii++)
    {
        if(markersId[ii])
        {
            var coord = new google.maps.LatLng(parseFloat(markersPos[ii].lat()), parseFloat(markersPos[ii].lng()));
            arrayDeCoordenadas.push(coord);
        }
    }

    var color=colores();
    poligono = new google.maps.Polyline({
      path: arrayDeCoordenadas,
      strokeColor: color,
      strokeOpacity: 1.0,
      strokeWeight: 2
    });

    allPoligonosDelete.push(poligono);

    poligono.setMap(map);
}


function verPosibleRecorrido(){
    var html="";
    var arrayDeCoordenadas = [];
    for(ii=0;ii<markersId.length;ii++)
    {
        if(markersId[ii])
        {
            var coord = new google.maps.LatLng(parseFloat(markersPos[ii].lat()), parseFloat(markersPos[ii].lng()));
            arrayDeCoordenadas.push(coord);
        }
    }

    poligonoNuevo = new google.maps.Polyline({
      path: arrayDeCoordenadas,
      strokeColor: "#FF0000",
      strokeOpacity: 1.0,
      strokeWeight: 2
    });

    allPoligonosDelete.push(poligonoNuevo);

    poligonoNuevo.setMap(map);
}


function guardarPunto(){
    var html="";

    //Debe haber elegido el TIPO de equipamiento y el Padre
    if($("#cmbTipo").val()=="" && $("#cmbEquipamiento").val()=="" && $("#txtTitulo").val()=="")
    {

        for(i=0;i<markersId.length;i++)
        {
            if(markersId[i])
            {
                html+="<input type='hidden' name='lat"+i+"' id='lat"+i+"' value='"+parseFloat(markersPos[i].lat())+"'>";
                html+="<input type='hidden' name='lng"+i+"' id='lng"+i+"' value='"+parseFloat(markersPos[i].lng())+"'>";
                html+="<input type='hidden' name='tipo"+i+"' id='tipo"+i+"' value='"+markersId[i].tipo+"'>";
            }
        }
        html+="<input type='hidden' name='tipoPunto' id='tipoPunto' value='"+$("#cmbTipo").val()+"'>";
        html+="<input type='hidden' name='padre' id='padre' value='"+$("#cmbEquipamiento").val()+"'>";
        html+="<input type='hidden' name='titulo' id='titulo' value='"+$("#txtTitulo").val()+"'>";
        html+="<input type='hidden' name='cantPuntos' id='cantPuntos' value='"+markersId.length+"'>";

        $("#recorrido").empty();
        $("#recorrido").append(html);

        var variables = $("#frmRecorrido").serialize();

        $.ajax(
        {
            type: "POST",
            url: "ajax/guardarrecorrido.php",
            data: variables,
            dataType : 'json',
            success: function(respuesta){
                poligono.setMap(null);
                recorrido = [];
                recorrido.length=0;

                //BORRO todas lsa marcas y poligonos
                for(i=0;i<markersId.length;i++)
                {
                    if(markersId[i])
                    {
                        aux = markersId[i];
                        aux.setMap(null);
                    }
                }
                markersId=new Array();
                markersPos=new Array();

                $("#recorrido").empty();
                //Agrego la coop en el mapa para poder cargar otros puntos
                ////marcarCoop();

                iniciarMapa();

                //vuelvo a cargar los datos de tipo y equipamiento
                $("#cmbTipo").empty();
                $("#cmbEquipamiento").empty();
                $("#txtTitulo").val("");
                ////cargarTipoEquipamiento();

                alert('Se cargo correctamente ');
            }
        });
    }
    else
    {
        var msg="";
        if($("#cmbTipo").val()=="")
            msg+="Debe seleccionar el tipo de equipo a cargar\n";
        if($("#cmbEquipamiento").val()=="")
            msg+="Debe seleccionar el equipamiento 'padre'\n";
        if($("#txtTitulo").val()=="")
            msg+="Debe ingresar un nombre para el equipamiento\n";
    }

}

function limpiarRuta(){
    for(i=0;i<allPoligonosDelete.length;i++){
        aux = allPoligonosDelete[i];
        aux.setMap(null);
    }
    if(poligono)
        poligono.setMap(null);

    recorrido = [];
    recorrido.length=0;

    //BORRO todas lsa marcas y poligonos
    for(i=0;i<markersId.length;i++)
    {
        if(markersId[i])
        {
            aux = markersId[i];
            aux.setMap(null);
        }
    }
    markersId=new Array();
    markersPos=new Array();

    for (var i = 0; i < allMarkersDelete.length; i++) {
        allMarkersDelete[i].setMap(null);
    }

    //iniciarMapa();

}

function cargarTipoEquipamiento(){
    $.ajax(
    {
        type: "POST",
        url: "ajax/listartipoequipamientos.php",
        data: "",
        dataType : 'json',
        success: function(respuesta){
            $('#cmbTipo option').remove();
            $.each(respuesta, function(val, text) {
                $("#cmbTipo").append("<option value='"+val.replace("@@@","")+"'>"+text+"</option>");
            });
        }
    });
}

function changeTipoEquipamiento(){
    //Actualizo el equipamiento
    $.ajax(
    {
        type: "POST",
        url: "../ajax/listarequipamientos.php",
        data: "t="+$("#cmbTipo").val(),
        dataType : 'json',
        success: function(respuesta){
            $('#cmbEquipamiento option').remove();
            $.each(respuesta, function(val, text) {
                $("#cmbEquipamiento").append("<option value='"+val.replace("@@@","")+"'>"+text+"</option>");
            });
        }
    });
}


function marcarCoop(){
    $.ajax(
    {
        type: "POST",
        url: "../ajax/recorrido.php",
        data: "ini=1",
        dataType : 'json',
        success: function(respuesta){
            var id = uniqueId();
            var pos = {lat: parseFloat(respuesta.lat), lng: parseFloat(respuesta.lng)};

            var marker = new google.maps.Marker({
                id:id,
                position: pos,
                map: map,
                tipo: 'coop',
                icon: '../images/google/coop.png'
            });

            markersId[id] = marker;
            markersPos[id] = marker.getPosition();
            allMarkersDelete.push(marker);

            map.setCenter(marker.getPosition());
        }
    });
}


function marcarPadre(){
    //Busco el equipamiento, que sera el padre en caso de guardar los datos.
    var idEquipamiento = $("#cmbEquipamiento").val();
    if(idEquipamiento){
        marcarEquipamientoMapa(idEquipamiento);

        //en el combo del equipamiento (a marcar) deberia aparecer SOLO los hijos que estan relacionado en la tabla equipamiento
        $.ajax(
        {
            type: "POST",
            url: "../ajax/listarequipamientos.php",
            data: "padre="+idEquipamiento,
            dataType : 'json',
            success: function(respuesta){
                $('#cmbEquipamientoArbol').empty();
                $('#cmbEquipamientoArbol option').remove();
                $.each(respuesta, function(val, text) {
                    $("#cmbEquipamientoArbol").append("<option value='"+val.replace("@@@","")+"'>"+text+"</option>");
                });
            }
        });
    }


}

function marcarEquipamientoMapa(idEquipamiento){
    $.ajax(
    {
        type: "POST",
        url: "../ajax/recorrido.php",
        data: "ini=0&idE="+idEquipamiento,
        dataType : 'json',
        success: function(respuesta){
            //Ejemplo de lo que llega: {"lat0":"-33.244143","lng0":"-61.355772","tipo0":"coop","lat1":"-33.24471753736992","lng1":"-61.355037689208984","tipo1":"poste","cantPuntos":"2"}

            limpiarRuta();
            nombreAnt="";
            for(i=0;i<respuesta.cantPuntos;i++){
                lat = respuesta["lat"+i];
                lng = respuesta["lng"+i];
                tipo = respuesta["tipo"+i];
                nombre = respuesta["nombrePunto"+i];
                icono = icons[tipo];


                var id = uniqueId();
                var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};

                var marker = new google.maps.Marker({
                    id:id,
                    position: pos,
                    map: map,
                    tipo: tipo,
                    icon: '../images/google/'+icono
                });

                //Agrego la info, el nombre, del punto final
                if(i>0 && nombreAnt!=nombre && nombre!="" && nombre!=null && nombreAnt!="")
                    agregarInformacion(marker, nombreAnt);

                nombreAnt = nombre;

                markersId[id] = marker;
                markersPos[id] = marker.getPosition();
                allMarkersDelete.push(marker);

                map.setCenter(marker.getPosition());

            }

            //Agrego la ultima informacion
            if(i>0)
                agregarInformacion(marker, nombre);

            //Marco la cooperativa
            if(respuesta.cantPuntos==0){
                marcarCoop();
            }

            verRecorrido();

            //Limpio los array, salvo el ultimo punto, porque tengo q guardar desde el ultimo punto en adelante
            //para seguir cargando puntos
            var ultimoId;
            var ultimoPos;
            for(i=0;i<markersId.length;i++)
            {
                if(markersId[i])
                {
                    ultimoId=markersId[i];
                    ultimoPos=markersPos[i];
                }
            }
            markersId=new Array();
            markersPos=new Array();
            markerId=0;
            var id = uniqueId();
            markersId[id]=ultimoId;
            markersPos[id]=ultimoPos;
            //allMarkersDelete.push(ultimoId);

        }
    });
}


function agregarInformacion(marker, message) {
    var infoWindow = new google.maps.InfoWindow({
        content: message
    });

    google.maps.event.addListener(marker, 'click', function () {
        infoWindow.open(map, marker);
    });
}




function guardarPuntoExistente(){
    var html="";
    //Debe haber elegido el TIPO de equipamiento y el Padre
    if($("#cmbEquipamientoArbol").val()!="")
    {
        if($("#cmbEquipamiento").val()!="")
        {
            html+="<input type='hidden' name='cmbEquipamiento' id='cmbEquipamiento' value='"+$("#cmbEquipamiento").val()+"'>";
        }

        idEquipo = $("#cmbEquipamientoArbol").val();
        for(i=0;i<markersId.length;i++)
        {
            if(markersId[i])
            {
                html+="<input type='hidden' name='lat"+i+"' id='lat"+i+"' value='"+parseFloat(markersPos[i].lat())+"'>";
                html+="<input type='hidden' name='lng"+i+"' id='lng"+i+"' value='"+parseFloat(markersPos[i].lng())+"'>";
                html+="<input type='hidden' name='tipo"+i+"' id='tipo"+i+"' value='"+markersId[i].tipo+"'>";
            }
        }
        html+="<input type='hidden' name='idEquipo' id='idEquipo' value='"+idEquipo+"'>";
        html+="<input type='hidden' name='cantPuntos' id='cantPuntos' value='"+markersId.length+"'>";

        $("#recorrido").empty();
        $("#recorrido").append(html);

        var variables = $("#frmRecorrido").serialize();

        $("#frmRecorrido").submit();
    }
    else
    {
        var msg="";
        if($("#cmbEquipamiento").val()=="")
            msg+="Debe seleccionar el equipamiento\n";
        alert(msg);
    }

}


function verEnElMapa(quever){
    if(quever == 'hijos')
    {
        url= "ajax/hijos.php";
        variables="idE="+$("#cmbEquipamientoHijos").val();
    }
    else
    {
        url= "ajax/mapacompleto.php";
        variables="";
        vaciarTodosArray();
    }
    mapaNuevoConCoop();
    $.ajax(
    {
        type: "POST",
        url: url,
        data: variables,
        dataType : 'json',
        success: function(respuesta){
            //Ejemplo de lo que llega: {"padre4":"11","id4":"1","lat4":"-33.23678511674881","lng4":"-61.36600971309235","tipo4":"olt","trayecto4":2,"nombrePunto4":"Splitter 1 - 1x2",.....}

            nombreAnt="";
            trayectoAnt="";

            var infowindow = new google.maps.InfoWindow();

            for(i=0;i<respuesta.cantPuntos;i++){
                lat = respuesta["lat"+i];
                lng = respuesta["lng"+i];
                tipo = respuesta["tipo"+i];
                nombre = respuesta["nombrePunto"+i];
                trayecto = respuesta["trayecto"+i];
                idpunto = respuesta["id"+i];
                idpadre = respuesta["padre"+i];
                icono = icons[tipo];

                var id = uniqueId();
                var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};

                //Si el trayecto empieza, el primer id es el del padre, lo invierto
                //esto es para el caso cuando se pisan los mismos padres.
                idAux=idpunto;
                if(trayecto != trayectoAnt)
                {
                    idpunto= idpadre;
                    idpadre='';
                }

                var marker = new google.maps.Marker({
                    id:id,
                    idpunto:idpunto,
                    idpadre:idpadre,
                    position: pos,
                    map: map,
                    tipo: tipo,
                    icon: '../images/google/'+icono
                });

                //Cuando cambio de trayecto, marco en el mapa y limpio los array de las marcas, esto es para no
                //pisar lineas
                if(trayecto != trayectoAnt)
                {
                    verRecorrido();
                    vaciarUnArray(markersId);
                    vaciarUnArray(markersPos);
                    markersId=[];
                    markersPos=[];
                    trayectoAnt = trayecto;
                    nombreAnt = nombre;
                }

                //cambio el tam. del icon segun zoom
                google.maps.event.addListener(map, 'zoom_changed', function() {
                    var zoom = map.getZoom();
                    changeIconZoom(zoom);
                });

                //Evento del click, muestra la info segun el idpunto (id en la tabla) y tipo es en que tabla tengo q
                //buscar la info a mostrar
                google.maps.event.addListener(marker, 'click', (function (marker, i) {
                    return function () {
                        if(marker.tipo != MAPA_PUNTO && marker.tipo != 'fin'){
                            $.ajax({
                                url: '../ajax/infopunto.php?id='+marker.idpunto+'&tipo='+marker.tipo,
                                dataType : 'json',
                                success: function(respuesta){
                                  infowindow.setContent(respuesta.data);
                                  infowindow.open(map, marker);
                                }
                            });
                        }
                    }
                })(marker, i));

                markersId[id] = marker;
                markersPos[id] = marker.getPosition();
                allMarkersDelete.push(marker);

                map.setCenter(marker.getPosition());
            }

            //Marco la cooperativa
            //esto es por si no hay puntos.
            if(respuesta.cantPuntos==0){
                marcarCoop();
            }

            //Muestro el ultimo recorrido, que quedo sin mostrarse en el for
            verRecorrido();

            //Limpio los array, salvo el ultimo punto, porque tengo q guardar desde el ultimo punto en adelante
            //para seguir cargando puntos
            var ultimoId;
            var ultimoPos;
            for(i=0;i<markersId.length;i++)
            {
                if(markersId[i])
                {
                    ultimoId=markersId[i];
                    ultimoPos=markersPos[i];
                }
            }
            vaciarUnArray(markersId);
            vaciarUnArray(markersPos);
            markersId=[];
            markersPos=[];
            markerId=0;
            var id = uniqueId();
            markersId[id]=ultimoId;
            markersPos[id]=ultimoPos;
        }
    });
}


function listarCiudades(){
    $.ajax(
    {
        type: "POST",
        url: "../ajax/listarciudades.php",
        data: "",
        dataType : 'json',
        success: function(respuesta){
            $('#cmbCliente option').remove();
            $.each(respuesta, function(val, text) {
                $("#cmbCiudad").append("<option value='"+val.replace("@@@","")+"'>"+text+"</option>");
            });
        }
    });
}