var map;
var markersId=new Array();
var circulosId=new Array();
var markersPos = new Array();
var poligono;
var recorrido= new Array();
var markerId=0;
var allMarkersDelete=[];

var allPoligonosDelete=[];

var latCliente;
var lngCliente;

var circuloBuscador;

var markerCliente=null;

var pathTriangulo = "M 20,10 1,20 1,1 z" ;
var pathCuadrado =  "M 5,5   l15,0  0,15  -15,0  0,-15";

var uniqueId = function()
{
    return ++markerId;
};

function mapaVacio(){
    generarMapaMarcarCliente('map', 16,-35.001153, -61.039800, '');
    marcarCoop();
}


/*MARCAR CLIENTE*/
function iniciarMapa(lat, lng){
    //Borro todo asi puedo volver a generar el mapa vacio
    markersId=new Array();
    circulosId=new Array();
    markersPos = new Array();
    poligono=null;
    recorrido= new Array();
    markerId=0;
    allMarkersDelete=[];

    generarMapaMarcarCliente('map', 16, lat, lng, '');
}

function generarMapaMarcarCliente(div, zoom, lat, long, tipoMapa){
    marcarCoop();
    generarMapaVacio(div, zoom, lat, long, tipoMapa);
    eventoClickMarcarCliente();
    //eventoDobleClickMarcarCliente();
}

function generarMapaMarcarClienteSoloVer(div, zoom, lat, long, tipoMapa){
    marcarCoop();
    generarMapaVacio(div, zoom, lat, long, tipoMapa);
}

function generarMapaVacio(div, zoom, lat, long, tipoMapa){
    if(tipoMapa == 'satelital')
        tipoMapa = google.maps.MapTypeId.SATELLITE;
    else if(tipoMapa == 'fisico')
        tipoMapa = google.maps.MapTypeId.TERRAIN;
    else if(tipoMapa == 'hibrido')
        tipoMapa = google.maps.MapTypeId.HYBRID;
    else
        tipoMapa = google.maps.MapTypeId.ROADMAP;

    var options = {
        zoom: zoom
        , center: new google.maps.LatLng(lat, long)
        , mapTypeId: tipoMapa
        , mapTypeControl: true,
        mapTypeControlOptions: {
            style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR
        },
        navigationControl: true,
        navigationControlOptions: {
            style: google.maps.NavigationControlStyle.SMALL,
        }
    };
    map = new google.maps.Map(document.getElementById(div), options);
    // parche para la expo hay que arreglarlo Si vez esto haceme acordar
    if ( zoom !== 18)
    {
         // Create the search box and link it to the UI element.
        var input = document.getElementById('pac-input');
        var searchBox = new google.maps.places.SearchBox(input);
        map.controls[google.maps.ControlPosition.TOP_LEFT].push(input);

        // Bias the SearchBox results towards current map's viewport.
        map.addListener('bounds_changed', function()
        {
            searchBox.setBounds(map.getBounds());
        });

        searchBox.addListener('places_changed', function()
        {
            var places = $('#pac-input').val();
            if (places.length == 0)
            {
                return;
            }
            var geocoder = new google.maps.Geocoder();
            geocoder.geocode({ 'address': places}, geocodeResult);
        });
    }
    else
    {
        $('#lupaBuscadorMap').hide();
    }


}

function eventoClickMarcarCliente(){
    map.addListener('click', function(e) {
        obtenerCoordenadas(e, map);
        var pos = {lat: e.latLng.lat(), lng: e.latLng.lng()};

        if(markerCliente){
            markerCliente.setMap(null);
        }

        var markerCl = new google.maps.Marker({
            title: 'Cliente: '+$("#cmbCliente").val(),
            position: pos,
            map: map,
            tipo: 'cliente',
            icon: 'images/google/'+GOOGLE_MAP_CLIENTE_GENERICO
        });

        markerCliente = markerCl;

        eventoDobleClickMarcarCliente();
    });
}

function eventoDobleClickMarcarCliente(){

    if(markerCliente)
    {
        google.maps.event.addListener(markerCliente, 'dblclick', (function (markerCliente) {
            return function () {
                if((markerCliente) && $("#idCliPlan").val() !=""){
                    latCliente = markerCliente.getPosition().lat();
                    lngCliente = markerCliente.getPosition().lng();

                    //si ya tiene padre seleccionado volver al formulario
                    tienePadreSeleccionado($("#idCliPlan").val());

                    //iniciarMarcarPadre(latCliente, lngCliente);
                    //verClienteMapaPadre($("#idCliPlan").val());

                }
                else
                {
                    unescAlert(txtMapaAlertSeleccionarPlanCliente);
                }
            }
        })(markerCliente));
    }
}


function tienePadreSeleccionado(idCliPlan)
{
    $.ajax(
    {
        type: "POST",
        url: "ajax/cliente_tienepadre.php",
        data: "idCliPlan="+$("#idCliPlan").val(),
        dataType : 'json',
        success: function(respuesta){
            //Al modificar ubicacion del cliente te deja seleccionar equipamiento padre  si se descomenta dejara de pedir el padre
            /*
            if(respuesta.tiene == "1")
            {
                var lat = parentElemId('latitud');
                if (lat)
                {
                    lat.value = latCliente.toFixed(7);
                    lat.focus();
                }
                var lon = parentElemId('longitud');
                if (lon)
                    lon.value = lngCliente.toFixed(7);

                if (window.opener)
                {
                    window.opener.unescAlert(txtSeHanActualizadoCoord);
                    window.opener.focus();
                }
                setTimeout('window.close();', 100);
            }
            else
            */
            {
                iniciarMarcarPadre(latCliente, lngCliente);
                verClienteMapaPadre($("#idCliPlan").val());
            }
            $('#modalMarcarPadre').modal('toggle');
        }
    });
}


//Veo el cliente, no tiene evento click!
function verCliente(lat, lng){

    if($("#idCliPlan").val() == -1)
    {
        $('#modalInicioCliente').modal('toggle');
    }
    else
    {
        $('#modalModificarCliente').modal('toggle');
    }
    generarMapaMarcarCliente('map', 16, lat, lng, '');
    $.ajax(
    {
        type: "POST",
        url: "ajax/cliente_vercliente.php",
        data: "idPlan="+$("#idCliPlan").val(),
        dataType : 'json',
        success: function(respuesta){
            if(lat && lng)
            {
                var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};

                icono = respuesta.icono;

                var marker = new google.maps.Marker({
                    position: pos,
                    map: map,
                    tipo: 'Cliente',
                    icon: 'images/google/'+icono
                });

                if(markerCliente){
                    markerCliente.setMap(null);
                }
                markerCliente = marker;

                eventoDobleClickMarcarCliente();
                map.setCenter(marker.getPosition());

                google.maps.event.addListener(map, 'zoom_changed', function() {
                        var zoom = map.getZoom();
                        changeIconZoom(zoom);
                });
                if(respuesta.imgCliente)
                {
                    $("#divImagenTxt").css("display","block");
                    $("#imagenTxt").attr("src","verimagen.php?id="+respuesta.imgCliente);
                }
            }
        }
    });

}


function verClienteConPadre(idCliPlan, lat, lng)
{

    generarMapaVacio('map', 17, lat, lng, '');
    //verClienteMapaPadreSoloVer(idCliPlan);
    verClienteConHermanos(idCliPlan);
    setTimeout(function(){changeIconZoom(17)}, 1000);
}

/*FIN MARCAR CLIENTE*/


/*MARCAR PADRE*/
function iniciarMarcarPadre(lat, lng){

    //Borro todo asi puedo volver a generar el mapa vacio
    markersId=new Array();
    circulosId=new Array();
    markersPos = new Array();
    poligono=null;
    recorrido= new Array();
    markerId=0;
    allMarkersDelete=[];

    generarMapaMarcarPadre('map', 18, lat, lng, '');

    //Marco por default la coop
    marcarCoop();
}

function generarMapaMarcarPadre(div, zoom, lat, long, tipoMapa){
    generarMapaVacio(div, zoom, lat, long, tipoMapa);
    posiblesPadres(lat,long);
}



function verRecorrido(){
    var html="";
    var arrayDeCoordenadas = [];
    for(ii=0;ii<markersId.length;ii++)
    {
        if(markersId[ii])
        {
            var coord = new google.maps.LatLng(parseFloat(markersPos[ii].lat()), parseFloat(markersPos[ii].lng()));
            arrayDeCoordenadas.push(coord);
        }
    }

    poligono = new google.maps.Polyline({
      path: arrayDeCoordenadas,
      strokeColor: "#0000ff",
      strokeOpacity: 1.0,
      strokeWeight: 2
    });

    allPoligonosDelete.push(poligono);

    poligono.setMap(map);
}

//marco el cliente, sus hermanos y todo el recorrido hasta la
function verClienteConHermanos(idPlan){
    if(idPlan!="")
    {
        var infowindow = new google.maps.InfoWindow();
        //iniciarMarcarPadre();
        $.ajax(
        {
            type: "POST",
            url: "ajax/cliente_verclienteconhermanos.php",
            data: "idPlan="+idPlan,
            dataType : 'json',
            success: function(respuesta){
                //Ejemplo de lo que llega: {"lat0":"-33.244143","lng0":"-61.355772","tipo0":"coop","lat1":"-33.24471753736992","lng1":"-61.355037689208984","tipo1":"poste","cantPuntos":"2"}

                for(i=0;i<respuesta.cantPuntos;i++){
                    //Para ver si dibujo algun recorrido
                    var dibujoRecorridoHijo=1;

                    var idPunto = respuesta["id"+i];
                    var lat = respuesta["lat"+i];
                    var lng = respuesta["lng"+i];
                    var tipo = respuesta["tipo"+i];
                    var tipoDePunto = respuesta["tipoDePunto"+i];
                    var icono = icons[tipo];

                    idAnt= respuesta["id"+(i-1)];
                    idSig= respuesta["id"+(i+1)];

                    var id = uniqueId();
                    var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};

                    icon = icons[tipo];
                    icono = {
                        url: 'images/google/'+icon,
                    }
                    if (respuesta["tipo"+i] == MAPA_PUNTO)
                    {
                        icono =
                        {
                          url: '../images/vacio.png',
                        }
                    }

                    var marker = new google.maps.Marker({
                        id: id,
                        idPunto: idPunto,
                        position: pos,
                        map: map,
                        tipo: tipo,
                        icon: icono,
                        tipoDePunto: tipoDePunto,
                        idAnterior: idAnt,
                        idSiguiente: idSig
                    });

                    google.maps.event.addListener(marker, 'click', (function (marker) {
                        return function () {
                            if(marker.tipo != MAPA_PUNTO && marker.tipo != MAPA_COOP){
                                if(marker.idAnterior != 0)
                                    idInfoPunto = marker.idAnterior;
                                else
                                    idInfoPunto = marker.idPunto;
                                $.ajax({
                                    url: 'ajax/infopunto.php?id='+idInfoPunto+'&tipo='+marker.tipo,
                                    dataType : 'json',
                                    success: function(respuesta){
                                      infowindow.setContent(respuesta.data);
                                      infowindow.open(map, marker);
                                    }
                                });
                            }
                        }
                    })(marker));

                    markersId[id] = marker;
                    markersPos[id] = marker.getPosition();
                    allMarkersDelete.push(marker);

                    map.setCenter(marker.getPosition());

                    google.maps.event.addListener(map, 'zoom_changed', function() {
                        var zoom = map.getZoom();
                        changeIconZoom(zoom);
                    });
                }

                verRecorrido();

                //Marco cliente y hermanos
                latPadre = respuesta.latPadre;
                lngPadre = respuesta.lngPadre;

                //CLIENTE
                latCliente=respuesta.latCliente;
                lngCliente=respuesta.lngCliente;
                iconoCliente=respuesta.iconoCliente;

                marcarPuntoEnMapa(idPlan, latCliente, lngCliente, iconoCliente, 'cliente', latPadre, lngPadre, 1);

                //HERMANOS
                for(i=0;i<respuesta.cantHermanos;i++){
                    latHermano=respuesta["latHermano"+i];
                    lngHermano=respuesta["lngHermano"+i];
                    idHermano=respuesta["idHermano"+i];
                    iconoHermano=respuesta["iconoHermano"+i];

                    marcarPuntoEnMapa(idHermano, latHermano, lngHermano, iconoHermano, 'cliente', latPadre, lngPadre, 0);

                }

                //Limpio los array, salvo el ultimo punto, porque tengo q guardar desde el ultimo punto en adelante
                //para seguir cargando puntos
                var ultimoId;
                var ultimoPos;
                for(i=0;i<markersId.length;i++)
                {
                    if(markersId[i])
                    {
                        ultimoId=markersId[i];
                        ultimoPos=markersPos[i];
                    }
                }
                markersId=new Array();
                markersPos=new Array();
                markerId=0;
                var id = uniqueId();
                markersId[id]=ultimoId;
                markersPos[id]=ultimoPos;

                //var pos = {lat: parseFloat(latCliente), lng: parseFloat(lngCliente)};
                //map.setCenter(pos);

            }
        });
    }
}

function verClienteMapaPadreSoloVer(idPlan){
    if(idPlan!="")
    {
        var infowindow = new google.maps.InfoWindow();
        //iniciarMarcarPadre();
        $.ajax(
        {
            type: "POST",
            url: "ajax/cliente_vercliente.php",
            data: "idPlan="+idPlan+"&solover=1",
            dataType : 'json',
            success: function(respuesta){
                latCliente = respuesta.latCliente;
                lngCliente = respuesta.lngCliente;

                if(latCliente && lngCliente)
                {
                    var pos = {lat: parseFloat(latCliente), lng: parseFloat(lngCliente)};

                    icono=GOOGLE_MAP_CLIENTE_GENERICO;
                    if(respuesta.icono)
                        icono = respuesta.icono;

                    var marker = new google.maps.Marker({
                        position: pos,
                        map: map,
                        idpunto: idPlan,
                        tipo: 'cliente',
                        icon: "images/google/"+icono
                    });

                    google.maps.event.addListener(marker, 'click', (function (marker) {
                        return function () {
                            if(marker.tipo != MAPA_PUNTO && marker.tipo != MAPA_COOP){
                                $.ajax({
                                    url: 'ajax/infopunto.php?id='+marker.idpunto+'&tipo='+marker.tipo,
                                    dataType : 'json',
                                    success: function(respuesta){
                                      infowindow.setContent(respuesta.data);
                                      infowindow.open(map, marker);
                                    }
                                });
                            }
                        }
                    })(marker));

                    google.maps.event.addListener(map, 'zoom_changed', function() {
                        var zoom = map.getZoom();
                        changeIconZoom(zoom);
                    });

                    var cityCircle = new google.maps.Circle({
                        strokeColor: 'grey',
                        strokeOpacity:0.5,
                        strokeWeight: 2,
                        fillColor: 'grey',
                        fillOpacity: 0.3,
                        map: map,
                        center: marker.getPosition(),
                        radius: 100
                    });

                    circulosId[0] = cityCircle;

                    lat = respuesta.latpadre;
                    lng = respuesta.lngpadre;
                    tipo = respuesta.tipopadre;
                    nombre = respuesta.nombrePuntoPadre;
                    idpunto = respuesta.id;
                    icono = icons[tipo];

                    var id = uniqueId();
                    var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};

                    var markerPadre = new google.maps.Marker({
                        id: id,
                        idpunto: idpunto,
                        position: pos,
                        map: map,
                        tipo: tipo,
                        icon: 'images/google/'+icono
                    });
                    google.maps.event.addListener(map, 'zoom_changed', function() {
                        var zoom = map.getZoom();
                        changeIconZoom(zoom);
                    });



                    //Evento del click, muestra la info segun el idpunto (id en la tabla) y tipo es en que tabla tengo q
                    //buscar la info a mostrar
                    google.maps.event.addListener(markerPadre, 'click', (function (markerPadre) {
                        return function () {
                            if(markerPadre.tipo != MAPA_PUNTO && markerPadre.tipo != MAPA_COOP){
                                $.ajax({
                                    url: 'ajax/infopunto.php?id='+markerPadre.idpunto+'&tipo='+markerPadre.tipo,
                                    dataType : 'json',
                                    success: function(respuesta){
                                      infowindow.setContent(respuesta.data);
                                      infowindow.open(map, markerPadre);
                                    }
                                });
                            }
                        }
                    })(markerPadre));





                    //Si tiene padre llega latpadre y lngpadre
                    arrayDeCoordenadas=[];
                    if(respuesta.latpadre && respuesta.lngpadre && respuesta.lngpadre!=0 && respuesta.latpadre!=0)
                    {
                        coordpadre = new google.maps.LatLng(parseFloat(respuesta.latpadre), parseFloat(respuesta.lngpadre));
                        arrayDeCoordenadas.push(coordpadre);

                        coordcliente = new google.maps.LatLng(parseFloat(latCliente), parseFloat(lngCliente));
                        arrayDeCoordenadas.push(coordcliente);

                        poligono = new google.maps.Polyline({
                            path: arrayDeCoordenadas,
                            strokeColor: "#FF0000",
                            strokeOpacity: 1.0,
                            strokeWeight: 2
                        });

                        poligono.setMap(map);
                    }

                    map.setCenter(marker.getPosition());
                }
            }
        });
    }
}


function verClienteMapaPadre(idPlan){
    if(idPlan!="")
    {
        var infowindow = new google.maps.InfoWindow();
        //iniciarMarcarPadre();
        $.ajax(
        {
            type: "POST",
            url: "ajax/cliente_vercliente.php",
            data: "idPlan="+idPlan,
            dataType : 'json',
            success: function(respuesta){
                if(latCliente && lngCliente)
                {
                    var pos = {lat: parseFloat(latCliente), lng: parseFloat(lngCliente)};

                    icono=GOOGLE_MAP_CLIENTE_GENERICO;
                    if(respuesta.icono)
                        icono = respuesta.icono;

                    var marker = new google.maps.Marker({
                        position: pos,
                        map: map,
                        idpunto: idPlan,
                        tipo: 'cliente',
                        icon: "images/google/"+icono
                    });

                    google.maps.event.addListener(marker, 'click', (function (marker) {
                        return function () {
                            if(marker.tipo != MAPA_PUNTO && marker.tipo != MAPA_COOP){
                                $.ajax({
                                    url: 'ajax/infopunto.php?id='+marker.idpunto+'&tipo='+marker.tipo,
                                    dataType : 'json',
                                    success: function(respuesta){
                                      infowindow.setContent(respuesta.data);
                                      infowindow.open(map, marker);
                                    }
                                });
                            }
                        }
                    })(marker));
                    google.maps.event.addListener(map, 'zoom_changed', function() {
                        var zoom = map.getZoom();
                        changeIconZoom(zoom);
                    });


                    var cityCircle = new google.maps.Circle({
                        strokeColor: 'grey',
                        strokeOpacity: 0.75,
                        strokeWeight: 2,
                        fillColor: 'grey',
                        fillOpacity: 0.3,
                        map: map,
                        center: marker.getPosition(),
                        radius: 100
                    });

                    circulosId[0] = cityCircle;
                    //Si tiene padre llega latpadre y lngpadre
                    arrayDeCoordenadas=[];
                    if(respuesta.latpadre && respuesta.lngpadre && respuesta.lngpadre!=0 && respuesta.latpadre!=0)
                    {
                        coordpadre = new google.maps.LatLng(parseFloat(respuesta.latpadre), parseFloat(respuesta.lngpadre));
                        arrayDeCoordenadas.push(coordpadre);

                        coordcliente = new google.maps.LatLng(parseFloat(latCliente), parseFloat(lngCliente));
                        arrayDeCoordenadas.push(coordcliente);

                        poligono = new google.maps.Polyline({
                            path: arrayDeCoordenadas,
                            strokeColor: "#FF0000",
                            strokeOpacity: 1.0,
                            strokeWeight: 2
                        });

                        poligono.setMap(map);
                    }

                    map.setCenter(marker.getPosition());
                }
            }
        });
    }
    else
    {
        //Es el caso que no selecciono plan ni tecnologia
    }
}

function obtenerCoordenadas(e, map){
    recorrido.push(e.latLng);
}

function posiblesPadres(lat,long){
    $.ajax(
    {
        type: "POST",
        url: "ajax/padrescliente.php",
        data: "idCliPlan="+$("#idCliPlan").val()+"&id_t_conex="+$("#tipoconexion").val()+"&id_plan="+$("#id_plan").val()+"&lat="+lat+"&long="+long,
        dataType : 'json',
        success: function(respuesta){
            //Ejemplo de lo que llega: {"padre4":"11","id4":"1","lat4":"-33.23678511674881","lng4":"-61.36600971309235","tipo4":"olt","trayecto4":2,"nombrePunto4":"Splitter 1 - 1x2",.....}
            var infowindow = new google.maps.InfoWindow();
            for(i=0;i<respuesta.cantPuntos;i++){
                lat = respuesta["lat"+i];
                lng = respuesta["lng"+i];
                tipo = respuesta["tipo"+i];
                nombre = respuesta["nombrePunto"+i];
                vacancia = respuesta["vacancia"+i];
                salidas = respuesta["salidas"+i];
                color_buffer = respuesta["color_buffer"+i];
                color_fibra = respuesta["color_fibra"+i];
                idpunto = respuesta["id"+i];
                icono = icons[tipo];

                var id = uniqueId();
                var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};

                if (color_fibra == null)
                    color_fibra = '#46ab8c';
                else
                    color_fibra =  intToRGB(color_fibra);

                if (color_buffer == null)
                    color_buffer = '#000001';
                else
                    color_buffer =  intToRGB(color_buffer);

                if (color_fibra !== '#46ab8c' &&  color_buffer == '#46ab8c')
                    color_buffer = color_fibra;

                icono = {
                    url: 'images/google/'+icons[tipo],
                }


                var marker = new google.maps.Marker({
                    id: id,
                    idpunto: idpunto,
                    vacancia: vacancia,
                    position: pos,
                    map: map,
                    tipo: tipo,
                    icon: icono,
                    nombreSelectAtrPadre: respuesta["nombreSelectAtrPadre"]
                });
                if (vacancia <= 0)
                    color = 'red';
                else if(vacancia == 1)
                    color = 'orange';
                else
                    color = 'green';
                var cityCircle = new google.maps.Circle({
                    strokeColor: color,
                    strokeOpacity: 1,
                    strokeWeight: 2,
                    fillColor: color,
                    fillOpacity: 0.6,
                    map: map,
                    center: marker.getPosition(),
                    radius:35
                });


                //Evento del click, muestra la info segun el idpunto (id en la tabla) y tipo es en que tabla tengo q
                //buscar la info a mostrar
                google.maps.event.addListener(marker, 'click', (function (marker, i) {
                    return function () {
                        if(marker.tipo != MAPA_PUNTO && marker.tipo != MAPA_COOP){
                            $.ajax({
                                url: 'ajax/infopunto.php?id='+marker.idpunto+'&tipo='+marker.tipo,
                                dataType : 'json',
                                success: function(respuesta){
                                  infowindow.setContent(respuesta.data);
                                  infowindow.open(map, marker);
                                }
                            });
                        }
                    }
                })(marker, i));

                google.maps.event.addListener(marker, 'dblclick', (function (marker, i) {

                    return function () {
                        if(this.vacancia > 0 || this.vacancia == null || $("#idCliPlan").val() != '-1')
                        {
                            var idPadre = marker.idpunto;
                            var lat = parentElemId('latitud');
                            if (lat)
                            {
                                lat.value = latCliente.toFixed(7);
                                lat.focus();
                            }
                            var lon = parentElemId('longitud');
                            if (lon)
                                lon.value = lngCliente.toFixed(7);
                            //Actualizo el campo del padre
                            //Veo si es un dslam
                            var t_conexion = parentElemId("t_conexion");
                            if(t_conexion.value == "1" )

                                 var select = parentElemId("ds_"+marker.nombreSelectAtrPadre);
                            else
                                var select = parentElemId(marker.nombreSelectAtrPadre);

                            if (select)
                            {
                                //actualiza los combos si cambio, sino no hago nada
                                if(select.value != marker.idpunto)
                                {
                                    select.value = marker.idpunto;
                                    if(select.onchange)
                                    {
                                        select.onchange();
                                    }
                                }
                            }

                            if (window.opener)
                            {
                                window.opener.unescAlert(txtSeHanActualizadoCoord);
                                window.opener.focus();
                            }
                            setTimeout('window.close();', 100);
                        }
                        else
                        {
                            if (this.tipo == TSUB_SANGR || this.tipo == TSUB_DISTRIB)
                            {
                                $('#modalEquipamientoSinVacancia').modal('toggle');
                            }
                            else
                            {
                                var idPadre = marker.idpunto;
                                var lat = parentElemId('latitud');
                                if (lat)
                                {
                                    lat.value = latCliente.toFixed(7);
                                    lat.focus();
                                }
                                var lon = parentElemId('longitud');
                                if (lon)
                                    lon.value = lngCliente.toFixed(7);
                                //Actualizo el campo del padre
                                //Veo si es un dslam
                                var t_conexion = parentElemId("t_conexion");
                                if(t_conexion.value == "1" )
                                    var select = parentElemId("ds_"+marker.nombreSelectAtrPadre);
                                else
                                    var select = parentElemId(marker.nombreSelectAtrPadre);

                                if (select)
                                {
                                    //actualiza los combos si cambio, sino no hago nada
                                    if(select.value != marker.idpunto)
                                    {
                                        select.value = marker.idpunto;
                                        if(select.onchange)
                                        {
                                            select.onchange();
                                        }
                                    }
                                }

                                if (window.opener)
                                {
                                    window.opener.unescAlert(txtSeHanActualizadoCoord);
                                    window.opener.focus();
                                }
                                setTimeout('window.close();', 100);
                            }
                        }

                    }
                })(marker, i));

                markersId[id] = marker;
                markersPos[id] = marker.getPosition();
                allMarkersDelete.push(marker);

                //map.setCenter(marker.getPosition());
            }

            //cambio el tam. del icon segun zoom
            google.maps.event.addListener(map, 'zoom_changed', function() {
                    var zoom = map.getZoom();
                    changeIconZoom(zoom);
            });

            if(i==0)
            {
                $("#continuar").css("display","none");
                //NO HAY PADRES, seguramente no hay tecnologia seleccionada
                var lat = parentElemId('latitud');
                if (lat)
                {
                    lat.value = latCliente.toFixed(7);
                    lat.focus();
                }
                var lon = parentElemId('longitud');
                if (lon)
                    lon.value = lngCliente.toFixed(7);

                /*
                if (window.opener)
                {
                    window.opener.unescAlert(txtSeHanActualizadoCoord);
                    window.opener.focus();
                }
                setTimeout('window.close();', 100);
                */

                $("#continuar").css("display","none");
                $("#posiblePadre").css("margin-left", "40%");
                $("#salir").css("display","inline");
            }
            else
            {
                $("#continuar").css("display","inline");
                $("#posiblePadre").css("margin-left", "0px");
                $("#salir").css("display","none");
            }

            //cambio el tam. del icon segun zoom
            var zoom = map.getZoom();
            changeIconZoom(zoom);
        }
    });

}


function verClientes(lat, lng)
{
    generarMapaVacio('map', 16, lat, lng, '');
    //Marco por default la coop
    marcarCoop();
    $.ajax(
    {
        type: "POST",
        url: "ajax/cliente_verenmapacliente.php",
        data: "",
        dataType : 'json',
        success: function(respuesta){
            //Ejemplo de lo que llega: {"padre4":"11","id4":"1","lat4":"-33.23678511674881","lng4":"-61.36600971309235","tipo4":"olt","trayecto4":2,"nombrePunto4":"Splitter 1 - 1x2",.....}
            var infowindow = new google.maps.InfoWindow();

            for(i=0;i<respuesta.cantPuntos;i++){
                lat = respuesta["lat"+i];
                lng = respuesta["lng"+i];
                tipo = respuesta["tipo"+i];
                idpunto = respuesta["id"+i];
                clientes = respuesta["clientes"+i];
                icon = tipo;

                var id = uniqueId();
                var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};

                if (color_buffer == null)
                    color_buffer = '#000001';
                if (color_fibra == null)
                    color_fibra = '#46ab8c';
                icono = {
                    url: 'images/google/'+icon,
                }

                var marker = new google.maps.Marker({
                    id: id,
                    idpunto: idpunto,
                    position: pos,
                    map: map,
                    tipo: tipo,
                    icon: icono
                });

                //cambio el tam. del icon segun zoom
                google.maps.event.addListener(map, 'zoom_changed', function() {
                    var zoom = map.getZoom();
                    changeIconZoom(zoom);

                });

                //Evento del click, muestra la info segun el idpunto (id en la tabla) y tipo es en que tabla tengo q
                //buscar la info a mostrar
                google.maps.event.addListener(marker, 'click', (function (marker, i) {
                    return function () {
                        if(marker.tipo != MAPA_PUNTO && marker.tipo != MAPA_COOP){
                            $.ajax({
                                url: 'ajax/infopunto.php?id='+marker.idpunto+'&tipo='+marker.tipo,
                                dataType : 'json',
                                success: function(respuesta){
                                  infowindow.setContent(respuesta.data);
                                  infowindow.open(map, marker);
                                }
                            });
                        }
                    }
                })(marker, i));

                markersId[id] = marker;
                markersPos[id] = marker.getPosition();
                allMarkersDelete.push(marker);


                //marco los clientes si tiene
                //agrego coordenadas del padre para hacer los poligonos
                arrayDeCoordenadas = [];

                if(clientes)
                {
                    //LAT@LONG|NOMBRE#IDCLIENTE$$$
                    clientesArray = clientes.split("$$$");
                    for(ii=0;ii<clientesArray.length;ii++)
                    {
                        latc = clientesArray[ii].substring(0, clientesArray[ii].indexOf("@"));
                        lngc = clientesArray[ii].substring(clientesArray[ii].indexOf("@")+1, clientesArray[ii].indexOf("%"));
                        iconoc = clientesArray[ii].substring(clientesArray[ii].indexOf("%")+1, clientesArray[ii].indexOf("|"));
                        nombrec = clientesArray[ii].substring(clientesArray[ii].indexOf("|")+1, clientesArray[ii].indexOf("#"));
                        idclientec = clientesArray[ii].substring(clientesArray[ii].indexOf("#")+1);

                        var id = uniqueId();
                        var pos = {lat: parseFloat(latc), lng: parseFloat(lngc)};


                        icono=GOOGLE_MAP_CLIENTE_GENERICO;
                        if(iconoc)
                            icono = iconoc;


                        var marker = new google.maps.Marker({
                            id:id,
                            idpunto:idclientec,
                            position: pos,
                            map: map,
                            tipo: 'cliente',
                            icon: 'images/google/'+icono
                        });


                        //Evento del click, muestra la info segun el idpunto (id en la tabla) y tipo es en que tabla tengo q
                        //buscar la info a mostrar
                        google.maps.event.addListener(marker, 'click', (function (marker, i) {
                            return function () {
                                $.ajax({
                                    url: 'ajax/infopunto.php?id='+marker.idpunto+'&tipo='+marker.tipo,
                                    dataType : 'json',
                                    success: function(respuesta){
                                      infowindow.setContent(respuesta.data);
                                      infowindow.open(map, marker);
                                    }
                                });
                            }
                        })(marker, i));

                        markersId[id] = marker;
                        markersPos[id] = marker.getPosition();
                        allMarkersDelete.push(marker);

                        coord = new google.maps.LatLng(parseFloat(lat), parseFloat(lng));
                        arrayDeCoordenadas.push(coord);

                        coord = new google.maps.LatLng(parseFloat(latc), parseFloat(lngc));
                        arrayDeCoordenadas.push(coord);
                    }

                    poligono = new google.maps.Polyline({
                        path: arrayDeCoordenadas,
                        strokeColor: "#FF0000",
                        strokeOpacity: 1.0,
                        strokeWeight: 2
                    });

                    poligono.setMap(map);
                }


                //map.setCenter(marker.getPosition());
            }

            //Clientes sin padre o que solo estan marcados en el mapa
            clientessinpadre = respuesta["clientessinpadre"];
            if(clientessinpadre)
            {
                //LAT@LONG|NOMBRE#IDCLIENTE$$$
                clientesSinPadreArray = clientessinpadre.split("$$$");
                for(ii=0;ii<clientesSinPadreArray.length;ii++)
                {
                    latc = clientesSinPadreArray[ii].substring(0, clientesSinPadreArray[ii].indexOf("@"));
                    lngc = clientesSinPadreArray[ii].substring(clientesSinPadreArray[ii].indexOf("@")+1, clientesSinPadreArray[ii].indexOf("%"));
                    iconoc = clientesSinPadreArray[ii].substring(clientesSinPadreArray[ii].indexOf("%")+1, clientesSinPadreArray[ii].indexOf("|"));
                    nombrec = clientesSinPadreArray[ii].substring(clientesSinPadreArray[ii].indexOf("|")+1, clientesSinPadreArray[ii].indexOf("#"));
                    idclientec = clientesSinPadreArray[ii].substring(clientesSinPadreArray[ii].indexOf("#")+1);

                    var id = uniqueId();
                    var pos = {lat: parseFloat(latc), lng: parseFloat(lngc)};


                    icono=GOOGLE_MAP_CLIENTE_GENERICO;
                    if(iconoc)
                        icono = iconoc;

                    var marker = new google.maps.Marker({
                        id:id,
                        idpunto:idclientec,
                        position: pos,
                        map: map,
                        tipo: 'cliente',
                        icon: 'images/google/'+icono
                    });

                    //Evento del click, muestra la info segun el idpunto (id en la tabla) y tipo es en que tabla tengo q
                    //buscar la info a mostrar
                    google.maps.event.addListener(marker, 'click', (function (marker, i) {
                        return function () {
                            $.ajax({
                                url: 'ajax/infopunto.php?id='+marker.idpunto+'&tipo='+marker.tipo,
                                dataType : 'json',
                                success: function(respuesta){
                                  infowindow.setContent(respuesta.data);
                                  infowindow.open(map, marker);
                                }
                            });
                        }
                    })(marker, i));

                    markersId[id] = marker;
                    markersPos[id] = marker.getPosition();
                    allMarkersDelete.push(marker);
                }
            }

        }
    });
}




function listarClientes(){
    $.ajax(
    {
        type: "POST",
        url: "ajax/listarclientes.php",
        data: "",
        dataType : 'json',
        success: function(respuesta){
            $('#cmbCliente option').remove();
            $('#cmbClientePadre option').remove();
            $.each(respuesta, function(val, text) {
                $("#cmbCliente").append("<option value='"+val.replace("@@@","")+"'>"+text+"</option>");
                $("#cmbClientePadre").append("<option value='"+val.replace("@@@","")+"'>"+text+"</option>");
            });
        }
    });
}


function planes(cmbCliente, cmbPadre){
    $.ajax(
    {
        type: "POST",
        url: "ajax/listarplanes.php",
        data: "id="+$("#"+cmbCliente).val(),
        dataType : 'json',
        success: function(respuesta){
            $('#'+cmbPadre+' option').remove();
            $.each(respuesta, function(val, text) {
                $("#"+cmbPadre).append("<option value='"+val.replace("@@@","")+"'>"+text+"</option>");
            });
        }
    });
}

function marcarPuntoEnMapa(id, lat, lng, iconoMostrar, tipo, latPadre, lngPadre, circulo){
    var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};
    var infowindow = new google.maps.InfoWindow();
    icono = {
        url: 'images/google/'+iconoMostrar,
    }
    var marker = new google.maps.Marker({
        id:id,
        position: pos,
        map: map,
        idpunto: id,
        tipo: tipo,
        icon: icono
    });

    google.maps.event.addListener(map, 'zoom_changed', function() {
        var zoom = map.getZoom();
        changeIconZoom(zoom);
    });

    google.maps.event.addListener(marker, 'click', (function (marker) {
        return function () {
            if(marker.tipo != MAPA_PUNTO && marker.tipo != MAPA_COOP){
                $.ajax({
                    url: 'ajax/infopunto.php?id='+marker.idpunto+'&tipo='+marker.tipo,
                    dataType : 'json',
                    success: function(respuesta){
                      infowindow.setContent(respuesta.data);
                      infowindow.open(map, marker);
                    }
                });
            }
        }
    })(marker));

    if(circulo == 1)
    {
        var cityCircle = new google.maps.Circle({
            strokeColor: 'grey',
            strokeOpacity: 0.75,
            strokeWeight: 2,
            fillColor: 'grey',
            fillOpacity: 0.3,
            map: map,
            center: marker.getPosition(),
            radius: 100
        });

        circulosId[0] = cityCircle;
    }

    allMarkersDelete.push(marker);
    //Si tiene padre llega latpadre y lngpadre
    arrayDeCoordenadas=[];
    if(latPadre && lngPadre && lngPadre!=0 && latPadre!=0)
    {
        coordpadre = new google.maps.LatLng(parseFloat(latPadre), parseFloat(lngPadre));
        arrayDeCoordenadas.push(coordpadre);

        coordcliente = new google.maps.LatLng(parseFloat(lat), parseFloat(lng));
        arrayDeCoordenadas.push(coordcliente);

        color="#ff0000";
        if(iconoMostrar==GOOGLE_MAP_CLIENTE_CONECTADO)
            color="#00ff00";

        poligono = new google.maps.Polyline({
            path: arrayDeCoordenadas,
            strokeColor: color,
            strokeOpacity: 1.0,
            strokeWeight: 2
        });

        poligono.setMap(map);
    }
}
