var map;
var markersId=new Array();
var circulosId=new Array();
var markersPos = new Array();
var poligono;
var recorrido= new Array();
var markerId=0;
var allMarkersDelete=[];

var allPoligonosDelete=[];

var latCliente;
var lngCliente;

var circuloBuscador;
var markerCliente=null;


function mapaVacio(){
    generarMapaMarcarNodo('map', 16,-35.001153, -61.039800, '');
    //marcarCoop();
}

function iniciarMapa(lat, lng){
    //Borro todo asi puedo volver a generar el mapa vacio
    markersId=new Array();
    circulosId=new Array();
    markersPos = new Array();
    poligono=null;
    recorrido= new Array();
    markerId=0;
    allMarkersDelete=[];

    generarMapaMarcarNodo('map', 16, lat, lng, '');
}

function generarMapaMarcarNodo(div, zoom, lat, long, tipoMapa){
    //marcarCoop();
    generarMapaVacio(div, zoom, lat, long, tipoMapa);
    eventoClickMarcarNodo();
    //eventoDobleClickMarcarNodo();
}

function generarMapaMarcarNodoSoloVer(div, zoom, lat, long, tipoMapa){
    //marcarCoop();
    generarMapaVacio(div, zoom, lat, long, tipoMapa);
}

function generarMapaVacio(div, zoom, lat, long, tipoMapa){
    if(tipoMapa == 'satelital')
        tipoMapa = google.maps.MapTypeId.SATELLITE;
    else if(tipoMapa == 'fisico')
        tipoMapa = google.maps.MapTypeId.TERRAIN;
    else if(tipoMapa == 'hibrido')
        tipoMapa = google.maps.MapTypeId.HYBRID;
    else
        tipoMapa = google.maps.MapTypeId.ROADMAP;

    var options = {
        zoom: zoom
        , center: new google.maps.LatLng(lat, long)
        , mapTypeId: tipoMapa
        , mapTypeControl: true,
        mapTypeControlOptions: {
            style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR
        },
        navigationControl: true,
        navigationControlOptions: {
            style: google.maps.NavigationControlStyle.SMALL,
        }
    };
    map = new google.maps.Map(document.getElementById(div), options);
}

function eventoClickMarcarNodo(){
    map.addListener('click', function(e){
        obtenerCoordenadas(e, map);
        var pos = {lat: e.latLng.lat(), lng: e.latLng.lng()};

        if(markerCliente){
            markerCliente.setMap(null);
        }

        var markerCl = new google.maps.Marker({
            title: 'Cliente: '+$("#cmbCliente").val(),
            position: pos,
            map: map,
            tipo: 'cliente',
            icon: 'images/google/'+GOOGLE_MAP_COOPERATIVA
        });

        markerCliente = markerCl;

        google.maps.event.addListener(markerCliente, 'dblclick', (function (markerCliente){
            return function () {
                if(markerCliente)
                {
                    ultLat = markerCliente.getPosition().lat();
                    ultLng = markerCliente.getPosition().lng();
                    var lat = parentElemId('latitud');
                    if (lat)
                    {
                        lat.value = ultLat.toFixed(7);;
                    }
                    var lon = parentElemId('longitud');
                    if (lon)
                    {
                        lon.value = ultLng.toFixed(7);
                    }
                    setTimeout('window.close();', 100);
                }
                else
                {
                    unescAlert(txtMapaAlertSeleccionarPlanCliente);
                }
            }
        })(markerCliente));    });
}

function verCliente(lat, lng){

    generarMapaMarcarNodo('map', 16, lat, lng, '');
    if(selNodo== -1)
    {
        $('#modalInicioNodo').modal('toggle');
    }
    else
    {
        $('#modalModificarNodo').modal('toggle');
        var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};
        var infowindow = new google.maps.InfoWindow();

        var marker = new google.maps.Marker({
            position: pos,
            map: map,
            idpunto: -1,
            tipo: 'coop',
            icon: "images/google/"+GOOGLE_MAP_COOPERATIVA
        });
        markerCliente=marker;
        google.maps.event.addListener(map, 'zoom_changed', function() {
            var zoom = map.getZoom();
            changeIconZoom(zoom);
        });
    }
}

function iniciarMarcarPadre(lat, lng){

    //Borro todo asi puedo volver a generar el mapa vacio
    markersId=new Array();
    circulosId=new Array();
    markersPos = new Array();
    poligono=null;
    recorrido= new Array();
    markerId=0;
    allMarkersDelete=[];

    generarMapaMarcarPadre('map', 18, lat, lng, '');

    //Marco por default la coop
    //marcarCoop();
}

function generarMapaMarcarPadre(div, zoom, lat, long, tipoMapa){
    generarMapaVacio(div, zoom, lat, long, tipoMapa);
    posiblesPadres(lat,long);
}

function obtenerCoordenadas(e, map){
    recorrido.push(e.latLng);
}

function verClientes(lat, lng)
{
    generarMapaVacio('map', 16, lat, lng, '');
    //Marco por default la coop
    //marcarCoop();

}

function marcarPuntoEnMapa(id, lat, lng){
    generarMapaVacio('map', 16, lat, lng, '');
    var pos = {lat: parseFloat(lat), lng: parseFloat(lng)};
    var infowindow = new google.maps.InfoWindow();

    var marker = new google.maps.Marker({
        position: pos,
        map: map,
        idpunto: id,
        tipo: 'coop',
        icon: "images/google/"+GOOGLE_MAP_COOPERATIVA
    });
    allMarkersDelete.push(marker);
    google.maps.event.addListener(map, 'zoom_changed', function() {
        var zoom = map.getZoom();
        changeIconZoom(zoom);
    });

    var cityCircle = new google.maps.Circle({
        strokeColor: 'grey',
        strokeOpacity: 0.75,
        strokeWeight: 2,
        fillColor: 'grey',
        fillOpacity: 0.3,
        map: map,
        center: marker.getPosition(),
        radius: 100
    });

    circulosId[0] = cityCircle;

}
